using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace SwrAddrTest
{
    public partial class Form1 : Form
    {
        [DllImport("SwrAddr.dll")]
        private extern static int SwrAddrInit(IntPtr callbackWnd, uint callbackMessage);
        [DllImport("SwrAddr.dll")]
        private extern static int SwrAddrFinish();
        [DllImport("SwrAddr.dll")]
        private extern static int SwrGetParam(int index);

        enum SWRCBMSG
        {
            SWRMSG_STATECHANGE,
            SWRMSG_PARAMCHANGE,
        };

        enum SWRSTATE
        {
            SWRSTATE_NOTFOUND,
            SWRSTATE_WATCH,
        };

        enum SWRSCENE
        {
            SWRSCENE_LOGO = 0,
            SWRSCENE_OPENING = 1,
            SWRSCENE_TITLE = 2,
            SWRSCENE_SELECT = 3,
            SWRSCENE_BATTLE = 5,
            SWRSCENE_LOADING = 6,
            SWRSCENE_SELECTSV = 8,
            SWRSCENE_SELECTCL = 9,
            SWRSCENE_LOADINGSV = 10,
            SWRSCENE_LOADINGCL = 11,
            SWRSCENE_LOADINGWATCH = 12,
            SWRSCENE_BATTLESV = 13,
            SWRSCENE_BATTLECL = 14,
            SWRSCENE_BATTLEWATCH = 15,
            SWRSCENE_SELECTSENARIO = 16,
            SWRSCENE_ENDING = 20,
            SWRSCENE_MAX,
        };

        enum SWRSCHAR
        {
            SWRCHAR_REIMU = 0,
            SWRCHAR_MARISA = 1,
            SWRCHAR_SAKUYA = 2,
            SWRCHAR_ALICE = 3,
            SWRCHAR_PATCHOULI = 4,
            SWRCHAR_YOUMU = 5,
            SWRCHAR_REMILIA = 6,
            SWRCHAR_YUYUKO = 7,
            SWRCHAR_YUKARI = 8,
            SWRCHAR_SUICA = 9,
            SWRCHAR_REISEN = 10,
            SWRCHAR_AYA = 11,
            SWRCHAR_KOMACHI = 12,
            SWRCHAR_IKU = 13,
            SWRCHAR_TENSHI = 14,
            SWRCHAR_ROMAN = 15,
            SWRCHAR_MAX = SWRCHAR_ROMAN,
        };

        enum SWRPARAM
        {
            SWRPARAM_SCENE = 0,
            SWRPARAM_COMMMODE,
            SWRPARAM_BATTLEMODE,
            SWRPARAM_LCHARID,
            SWRPARAM_RCHARID,
            SWRPARAM_LWINCOUNT,
            SWRPARAM_RWINCOUNT,
            SWRPARAM_MAX,
        };

        enum SWRCOMMMODE
        {
            SWRCOMMMODE_SERVER = 4,
            SWRCOMMMODE_CLIENT = 5,
            SWRCOMMMODE_WATCH = 6
        };

        private static UInt32 WM_APP = 0x8000;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SwrAddrInit(this.Handle, WM_APP);
            stateLabel.Text = "ss";
            sceneLabel.Text = "mȂ";
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            SwrAddrFinish();
        }

        private void Form1_SWRCallback(SWRCBMSG msg, int param1, int param2)
        {
            switch(msg) {
                case SWRCBMSG.SWRMSG_STATECHANGE:
                    if ((SWRSTATE)param1 == SWRSTATE.SWRSTATE_NOTFOUND)
                    {
                        stateLabel.Text = "ss";
                        sceneLabel.Text = "mȂ";
                    }
                    else
                    {
                        stateLabel.Text = "Ď";
                        Form1_SWRCallback(
                            SWRCBMSG.SWRMSG_PARAMCHANGE,
                            (int)SWRPARAM.SWRPARAM_SCENE,
                            SwrGetParam((int)SWRPARAM.SWRPARAM_SCENE));
                    }
                    break;
                case SWRCBMSG.SWRMSG_PARAMCHANGE:
                    if ((SWRPARAM)param1 == SWRPARAM.SWRPARAM_SCENE)
                    {
                        switch ((SWRSCENE)param2)
                        {
                            case SWRSCENE.SWRSCENE_LOGO:
                                sceneLabel.Text = "S";
                                break;
                            case SWRSCENE.SWRSCENE_OPENING:
                                sceneLabel.Text = "I[vjO";
                                break;
                            case SWRSCENE.SWRSCENE_TITLE:
                                sceneLabel.Text = "^Cg";
                                break;
                            case SWRSCENE.SWRSCENE_SELECT:
                                sceneLabel.Text = "LN^[ZNg";
                                break;
                            case SWRSCENE.SWRSCENE_SELECTSENARIO:
                                sceneLabel.Text = "ViIZNg";
                                break;
                            case SWRSCENE.SWRSCENE_BATTLE:
                                sceneLabel.Text = "ΐ풆";
                                break;
                            case SWRSCENE.SWRSCENE_SELECTCL:
                            case SWRSCENE.SWRSCENE_SELECTSV:
                                sceneLabel.Text = "ʐMLN^[ZNg";
                                break;
                            case SWRSCENE.SWRSCENE_BATTLECL:
                            case SWRSCENE.SWRSCENE_BATTLESV:
                                sceneLabel.Text = "ʐMΐ풆";
                                break;
                        }
                    }
                    break;
            }
       }

        protected override void WndProc(ref Message m)
        {
            if (m.Msg == WM_APP)
                Form1_SWRCallback((SWRCBMSG)(m.WParam.ToInt32() & 0xFFFF), m.WParam.ToInt32() >> 16, m.LParam.ToInt32());
            else
                base.WndProc(ref m);
        }
    }
}